/********************************************************************
:2014/04/14
  :PDSFormula.h
ԭʼ:
    :ļеĺCString͵Ĺʽ,ʽ,ʹ÷:
         (1)һCPDSFormula,CPDSFormula::SetFormulaеĲ,øýӿ,Ҫֶ
         (2)ɺCPDSFormula::AnalyseStringɶַĽ,m_listFormulaItem,ָЩʾ,Щʾ,
            ڳ,m_dConstNumberľڲֵ,ڳ,m_dConstNumberľʵֵ,
            ر˵,[-Χ/4]ĹʽᱻΪ[0-Χ/4],
            ڸòнγm_listCalculateFormula,¼νʽֵ            
         (3)ĳʵֵʱ,Ҫm_listCalculateFormula,ú͵ߴ糤/õm_dConstNumber,ٵCalculateResult,䷵ֵǽ
         ע:
         (1)PDSнʽ㷨,/Ա//궨һЩĶ
         (2)CPDSFormula::SemanticAnalysisǱ,ָЩڲ,Щǳ
            㷨:蹫ʽк5,ȼ5Ϊ,Ƿm_iFormulaTypeһ,һ,4Ϊ,5,ټһµĹʽm_iFormulaTypeһ,ټ3210
         (3)ʽm_listLengthVariableNamem_listAngleVariableName,ǰߴ,ߴǶ,,ʱһҪͬ͵ߴ/ߴַд뵽Ӧ
         (4)еĳԱpublic,ȡ,Ҫʹ÷в,ûгĺ/

޸ļ¼:
  汾       ޸                ޸
*********************************************************************/
#ifndef PDSFORMULA_H
#define PDSFORMULA_H

#include <afxwin.h>
#include <afxtempl.h>

//ΪĿ㼶֮
#define PDS_F_OT_NULL         0x00000000  //
#define PDS_F_OT_ADD          0x00000001  //+  
#define PDS_F_OT_SUB          0x00000002  //-  
#define PDS_F_OT_MULT         0x00000004  //*  
#define PDS_F_OT_DIV          0x00000008  ///  
#define PDS_F_OT_LBRACKET     0x00000010  //(  
#define PDS_F_OT_RBRACKET     0x00000020  //)  
#define PDS_F_OT_SQR          0x00000040  // 
//Ĳʹַʾ
#define PDS_F_OT_SIN          0x00000080  //sin
#define PDS_F_OT_COS          0x00000100  //cos
#define PDS_F_OT_TG           0x00000200  //tg
#define PDS_F_OT_CTG          0x00000400  //ctg
#define PDS_F_OT_ARCSIN       0x00000800  //arcsin
#define PDS_F_OT_ARCCOS       0x00001000  //arccos
#define PDS_F_OT_ARCTG        0x00002000  //arctg
#define PDS_F_OT_ARCCTG       0x00004000  //arcctg

#define  PDS_FORMOULA_STACK_SIZE    100
#define  PDS_FOT_MAX_LENGTH           7  //ʹַʾĲַ󳤶

//ʽϢ
enum PDS_ERROR_INFO
{
  NoError             =0,   //ûд
  StackOverflow       =1,   //ջ
  ExpressionError     =2,   //ʽ(Ĳȷ)
  NOLBracket          =3,   //ֻ,û
  NORBracket          =4,   //ûƥ
  DivideZero          =5,   //Ϊ0
  SqrtError           =6,   //С0
  ArcsinError         =7,   //ݴ(ݱ[-1,1]֮)
  ArccosError         =8,   //ݴ(ݱ[-1,1]֮)
  StringError         =9    //ַڴ
};

//ʽ
class CPDSFormulaItem
{
public:
  int m_iType;  //=1 (Ĭ), =2 m_pData1/m_pData2, =3 ڲ, =4 
  int m_iOperatorType;  //m_iType=1ʱЧ,ȡֵΧPDS_F_OT_NULL~PDS_F_OT_ARCCTG
  int m_iUnit;  //λ,ڽǶȹʽ,ñΪ-1,m_bOperator=FALSEʱЧ,Ĭ-1,<<PDSUnit.h>>
  int m_iPrecision;  //λ,תַʱʹ,Ĭ-1,<<PDSUnit.h>>

  double m_dConstNumber;  //ֵ,ȿΪϵҲΪ,λΪm_iUnit,λΪӢʾʱ,תС

  void* m_pData1;  //ָ1,ɸʵҪָ
  void* m_pData2;  //ָ2
  CString m_strText;  //ַ,ɸʵҪָ

  int m_iIndex;  //¼thisеֵ

  int m_iPower;  //¼thisݴ,Ϊ,ֵΪ1,Ϊ0

public:
  CPDSFormulaItem(void);
  CPDSFormulaItem(CPDSFormulaItem& rhs);
  ~CPDSFormulaItem(void);
  CPDSFormulaItem& operator=(CPDSFormulaItem& rhs);
  BOOL operator==(CPDSFormulaItem& rhs);
  BOOL operator!=(CPDSFormulaItem& rhs);

  void Init(void);
};
typedef CList<CPDSFormulaItem,CPDSFormulaItem&> CPDSFormulaItemList;

//ַʱʹõ
class CPDSMeasurePos
{
public:
  CString m_strMeasureName;  //ڹʽߴ/ߴ
  int m_iMeasureIndex;  //ڹʽпʼλ
public:
  CPDSMeasurePos(void);
  CPDSMeasurePos(CPDSMeasurePos& rhs);
  ~CPDSMeasurePos(void);
  CPDSMeasurePos& operator=(CPDSMeasurePos& rhs);
  BOOL operator==(CPDSMeasurePos& rhs);
};
typedef CList<CPDSMeasurePos,CPDSMeasurePos&> CPDSMeasurePosList;

class CPDSFormula
{
public:
  BOOL m_bOldFormoula;  //=TRUE ɹʽ, =FALSE ¹ʽ
  int m_iFormulaType;  //ʽ, =1 ȹʽ(Ĭ), =2 Ƕȹʽ
  int m_iDPMM;  //ݵλ:dpmm(ÿ׵),ַڲλ
  int m_iUnit;  //ʽʱ,ʽȵλ
  int m_iPrecision;  //뵥λӦĳȾȷ
  CString m_strFormula;  //ûĹʽַ
  int m_iMantissa;  //ɹʽβӦϵͳλֵ,ĿΪ˷ֹλתʱ,ֻھɹʽЧ
  CStringList m_listLengthVariableName;  //ʾȵı
  CStringList m_listAngleVariableName;   //ʾǶȵı

  CPDSFormulaItemList  m_listFormulaItem;  //¼ַͨõĹʽ(ʽе˳빫ʽַһ)
  CPDSFormulaItemList  m_listCalculateFormula;  //Źʽ˳,ڼ

  PDS_ERROR_INFO m_ErrorInfo;  //ʽϢ

  //ʹõı
  WORD m_iPositionIndex;  //ַУַָĵǰλ

  CPDSFormulaItem m_CurrFormulaItem;  //ǰĵ
  CPDSMeasurePosList m_listMeasurePos;  //ַʱ,ַеߴͳߴƼַλ
  //ջֻڷַĹ
  CPDSFormulaItem m_arrFIStack1[PDS_FORMOULA_STACK_SIZE];  //дŲ
  int m_iStackTop1;  //0..ParserStackSize;ǰջλ

  CPDSFormulaItem m_arrFIStack2[2 * PDS_FORMOULA_STACK_SIZE];  //дŲͲ
  int m_iStackTop2;  //0..2 * ParserStackSize;ǰջλ

public:
  CPDSFormula(void);
  CPDSFormula(CString strFormula, int iDPMM, int iUnit, int iPrecision, BOOL bOldFormoula, int iFormulaType, CStringList& listLengthVariableName, CStringList& listAngleVariableName);
  ~CPDSFormula(void);

  void Init(void);

  //ú
  void SetFormula(CString strFormula, int iDPMM, int iUnit, int iPrecision, BOOL bOldFormoula, int iFormulaType, CStringList& listLengthVariableName, CStringList& listAngleVariableName);

  //жϹʽǷȷ
  //ֵ:
  //  =TRUE ʽȷ,=FALSE ʽ
  //˵:
  //  жϹʽаĳȳߴ/ǶȳߴǷڸҵ
  BOOL IsFormulaRight(void);

  //ñ
  void SetVariableName(CStringList& listLengthVariableName, CStringList& listAngleVariableName);

  //ַһһ
  void AnalyseString(void);

  //üm_listCalculateFormula
  void SetCalculateList(void);
  
  //ʽջ
  void Push1(CPDSFormulaItem Item);
  
  //ʽջ
  void Pop1(CPDSFormulaItem& Item);
  
  //ʽջ
  void Push2(CPDSFormulaItem Item);  
  
  //жϸʽвȼ
  //  []Item1,Item2ʽ
  //ֵ:
  //  =0 Item1ȼItem2; =1 Item1ȼItem2; =2 Item1ȼItem2
  //˵:
  // úвԹʽǷΪж
  int JudgePRI(CPDSFormulaItem Item1, CPDSFormulaItem Item2);
  
  //жϸĹʽвǵĿ㻹˫Ŀ()
  //  [] Item ʽ
  //ֵ:
  //  =TRUE ItemΪ˫Ŀ; =FALSE ItemĿ,
  BOOL IsDualOperator(CPDSFormulaItem Item);
  
  //ַеõÿʽ
  //ֵ:
  //  =TRUE ʾַȷ,=FALSE ʾַڴ
  //  ʽm_listFormulaItem
  //˵:
  //˼·:
  //1. ҳַеߴͳߴ,¼ߴ/ߴƺַеλ;
  //2. ڷַʱ,ͨλm_listMeasurePosѰ,ֱӷ,Ҳַͨһһ
  //3. ֤һʽΪ,ҲͲ(Ӽ˳)
  BOOL GetStringFormulaItem(void);

  //ҳm_strFormulaаĳߴ,listMeasurePos
  void GetMeasureInfo(CPDSMeasurePosList& listMeasurePos);

  //õַеĵ,,,
  //ֵ:
  //  0 ַ󣬼ǱҲǲ
  //  1 ַβ
  //  2 ַ:!
  //  3 ֵΪ
  //  4 ֵΪ
  //  5 ֵΪŲ
  //  6 ֵΪַ
  //˵:
  //  ֿͷ
  //  ֻڵλΪӢƷ£Žзķ
  int NextFormulaItem(void);
  
  //m_listMeasurePosвҶӦMeasurePos
  //:
  //  iIndex      
  //  MeasurePos  []ҵӦıλ,ֵΪTRUEʱЧ
  //ֵ:
  //  =TRUE ҵ, =FALSE ûҵ
  //˵
  //  ҵҵϢm_listMeasurePosƳ
  //  ޸ͬһλôڶ,ȡ
  //  ߴ/ߴƴ
  BOOL FindMeasureIndex(int iIndex, CPDSMeasurePos& MeasurePos);
  
  //жǷΪ:sin, cos ,tg, ctg, arcsin, arccos, arctg, arcctg
  //:
  //  strOperatorName  []
  //  iOperatorType    []
  //ֵ:
  // =TRUE iOperatorType, =FALSE iOperatorTypeʹ
  BOOL IsFunc(CString &strOperatorName, int &iOperatorType);

  //жǷΪ
  //:
  //  strVarName  []
  //ֵ:
  // =TRUE strVarName,=FALSE strVarNameʹ
  BOOL IsVar(CString &strVarName);
  
  //жһַǷΪ
  //:
  //  strOperatorName   []
  //  iOperatorType     []
  //ֵ
  //  =TRUE iOperatorType, =FALSE iOperatorTypeʹ
  //˵:
  //  ڸúж,ʽʹõǷš
  BOOL IsOperator(CString& strOperatorName, int& iOperatorType);
  
  //ҸǷΪߴ
  //ֵ:
  // =TRUE ҵ, =FALSE ûҵ
  BOOL FindVariableForName(CString strVarName);

  //
  //˵:
  //  Խm_listFormulaItem,ȷЩֱʾڲλ,Щʾ
  void SemanticAnalysis(void);

  //ݴ
  //:
  //  listFormulaItem   ʽ
  //  iPower            ݴ,=0 ʾ, =1 ʾ, = 2ʾ*,Դ
  void SetPower(CPDSFormulaItemList& listFormulaItem, int iPower);

  //ݴǷڸֵ
  //:
  //  listFormulaItem   
  //  iPower            ݴ, =0 ʾ, =1 ʾ, =2 ʾ*,Դ
  //ֵ:
  //  =TRUE ȷ, =FALSE 
  BOOL CheckPower(CPDSFormulaItemList& listFormulaItem, int iPower);

  //жϸǷ
  //:
  //  listFormulaItem   ʽ
  //  iIndexL           []ߵеֵ
  //  iIndexR           []iIndexLӦеֵ
  //ֵ:
  //  =TRUE ,(iIndexL,iIndexR)Ч, =FALSE û,Ч
  BOOL HaveBracket(CPDSFormulaItemList& listFormulaItem, int& iIndexL, int& iIndexR);

  //
  //:
  //  iMaxCount   
  //  iCount      ȡ
  //  alIndex     [],еalIndex[].GetCount()=iCount,ֵ0ʼ,ӴС
  void Permutation(int iMaxCount, int iCount, CArray<CList<int,int>,CList<int,int> >& alIndex);

  //ȡݴ,ʧ򷵻INT_MAX
  //ر˵:ʲôǼʧ?
  //  :A*B+CɼӺӵÿһݴβ,sqrt(A+B)ݲǳ2,sin(A)ǺĲǳ,ȵ
  //ֵ:
  //  ݴ,=0 ʾ, =1 ʾ, = 2ʾ*,Դ
  int GetPower(CPDSFormulaItemList& listFormulaItem);

  //
  //ر˵:
  //  ñ֮ǰ,Ҫm_listFormulaItem,ߴʵֵõm_dConstNumber,м!!!
  //ֵ:
  //  thisǳȹʽ,ôֵʾ,ɼΪڲ,thisǽǶȹʽ,ôֵǽǶ
  double CalculateResult(void);
  
  //ɹʽ
  double CalculateOldFormula(void);
  
  //¹ʽ
  double CalculateNewFormula(void);
  
  //˫Ŀ
  //:
  //  iOperator   
  //  dValue1     һ
  //  dValue2     ڶ
  //ֵ:
  //  (ݹʽ)
  CPDSFormulaItem CalculateValue1(int iOperator, double dValue1, double dValue2);
  
  //Ŀ
  //
  //  iOperator   
  //  dValue1     һ
  //ֵ:
  //  (ݹʽ)
  CPDSFormulaItem CalculateValue2(int iOperator, double dValue1);
};

#endif  // PDSFORMULA_H