#if !defined (WRITEAUTOCAD_H)
#define  WRITEAUTOCAD_H

#include "WriteDxfFile.h"

class CWriteAutoCAD : public CObject
{
private:
  double m_dScale;

  CPoint m_ptPatternOffset;  //ֽƫ

  CWriteDxfData m_Data;
  FILE *m_pDXFFile;   //ļָ
  int m_iHandleIndex;  //
  BOOL m_bVer15;  //=trueR15 ƵSpline=falseR12 ʵʵ
public:
  CWriteAutoCAD();
  ~CWriteAutoCAD();

  void Initial();

  //дļ
  //
  // strPath;  ļȫ·
  // Data 
  // bVer15 trueR15 ƵSpline=falseR12 ʵʵ
  //ֵ:
  //  =true ȷ=false·޷
  BOOL WriteFile(CString strPath, CWriteDxfData &DxfData, BOOL bVer15);

private:

  //ֽת豸
  //
  //  ptPoint ֽ
  //
  //  fx, fy Ӧ豸XYֵ
  void PttnToDP(CPoint ptPoint, float &fx, float &fy);

  //õ
  //ֵ
  //  ַ
  //ļеľͬ
  CString GetHandle();

  //HEADER
  //˵
  //ļm_pDXFFile
  void WriteHEADER();
  void WriteHEADER_12();
  void WriteHEADER_15();

  //TABLE
  //˵
  //ļm_pDXFFile
  void WriteTABLES();
  void WriteTABLES_12();
  void WriteTABLES_15();

  //BLOCKS
  //˵
  //ļm_pDXFFile m_Data
  void WriteBLOCKS();
  void WriteBLOCKS_15();

  //ֽ
  // 
  // PatternData Ϣ
  //˵
  //ļm_pDXFFile m_Data
  void WriteBLOCK(CPatternData &PatternData);

  //Entities
  //˵
  //ļm_pDXFFile m_Data
  void WriteENTITIES();


  //
  //
  //  iLayer 
  //  listCurveOfFile ߣ߶ڸ
  void WriteCurve(int iLayer, CCurveIDataList &listCurveOfFile);

  //Բ
  //
  //  iLayer 
  //  CurveData 
  void WriteArc(int iLayer, CCurveIData &CurveData);

  //Բ
  //
  //  iLayer 
  //  CurveData 
  void WriteCircle(int iLayer, CCurveIData &CurveData);

  //
  //
  //  iLayer 
  //  PointData 
  void WritePoint(int iLayer, CPoint ptPoint);

  //ֱ
  //
  //  iLayer 
  //  ptHead/ ptTail ֱ
  void WriteLine(int iLayer, CPoint ptHead, CPoint ptTail, COLORREF crColor);


  //
  //
  //  iLayer 
  //  CurveData 
  void WritePolyline(int iLayer, CCurveIData &CurveData);

  //
  //
  //  iLayer 
  //  CurveData 
  void WriteLWPolyline(int iLayer, CCurveIData &CurveData);

  //
  //
  //  iLayer 
  //  CurveData 
  void WriteSpline(int iLayer, CCurveIData &CurveData);

  //VERTEX
  //
  //  iLayer  
  //  ptPoint 
  void WriteVertex(int iLayer, CPoint ptPoint);

  //ı
  //
  //  iLayer 
  //  listTextOfFile ııڸ
  void WriteTexts(int iLayer, CTextIDataList &listTextOfFile);

  //дı
  //
  //  pfWrite ļ
  //  iLayer 
  //  TextData ı
  void WriteText(int iLayer, CTextIData TextData);

  //дı
  //
  //  iLayer 
  //  TextData ı
  void WriteMText(int iLayer, CTextIData TextData);

  //д
  //
  //  strInsertName 
  //  PointData 
  //  dAngle Ƕ
  void WriteInsert(CString strInsertName, CPoint PointData, double dAngle);

  //תAutoCADɫ
  CString ConvertColor(COLORREF crColor);


  void WriteOBJECT();

};


#endif